// Craig S. Kaplan
// Draw a blizzard by creating a random composition of snowflake SVG
// illustrations.  Demonstrates loading a large number of SVGs into
// a single sketch.  Note that this is adapted from an assignment in
// CS 116X Winter 2015: 
// https://www.student.cs.uwaterloo.ca/~cs106/Winter2015/assignments/a05/a05.pdf

// We're going to hold on to a bunch of PShapes, so it makes
// sense to stick them into an array.
PShape[] shapes;

void setup()
{
  size( 500, 500 );
  
  shapes = new PShape[ 12 ];
  
  for( int idx = 0; idx < 12; ++idx ) {
    // Now *this* is very interesting, take notice!
    // The information we pass as a parameter to 
    // loadShape() is just a String like any other.
    // So there's no reason it has to be a literal --
    // we can "generate" the file name using code
    // and then load that file into the right slot in
    // the array.  That way we save a lot of code
    // (though it took a while to write this comment...)
    shapes[idx] = loadShape( "snowflake" + (idx+1) + ".svg" );
  }
}

void draw()
{
  background( 180, 180, 255 );
  
  // Draw 250 random snowflakes at different positions 
  // and sizes.
  for( int idx = 0; idx < 250; ++idx ) {
    int which = int( random( shapes.length ) );
    float x = random( width );
    float y = random( height );
    
    float dim = random( 10, 40 );
    
    shape( shapes[which], x, y, dim, dim );
  }
  
  noLoop();
}

void keyPressed()
{
  save( "output.png" );
}