// Craig S. Kaplan
// A demonstration of saving vector data out to a PDF.  You
// should be able to open output.pdf in, say, Illustrator and
// work with the actual paths.

import processing.pdf.*;

PShape flower;
boolean recording;

void setup()
{
  size( 500, 500 );
  flower = loadShape( "flower.svg" );
  flower.disableStyle();
  shapeMode( CENTER );
  noStroke();
  
  recording = false;
}

void draw()
{
  if( recording ) {
    beginRecord( PDF, "output.pdf" );
  }
  
  background( 255 );
  noStroke();

  for ( int idx = 0; idx < 50; ++idx ) {
    float x = random( width );
    float y = random( height );

   // fill( 0, 200, 0 );
   // rect( x - 3, y, 6, 500 );

    fill( random( 255 ), random( 255 ), random( 255 ) );

    float fac = random( 0.15, 0.75 );
    shape( flower, x, y, flower.width * fac, flower.height * fac );
  }

  if( recording ) {
    recording = false;
    endRecord();
  }
  
  noLoop();
}

void keyPressed()
{
  recording = true;
  loop();
}